Page MenuHomeFreeBSD

Make linux metaports conditionally depend on x11/nvidia-driver
ClosedPublic

Authored by xmj on Sep 22 2014, 2:40 PM.

Details

Reviewers
swills
koobs
Summary

Reported in 193832 [1], users of x11/nvidia-driver will not currently be able
to install emulators/linux-c6 (or emulators/linux-f10) due to a conflict of
linux-{c6,f10}-dri with nvidia-driver in /compat/linux/usr/lib/libGL.so.1.

Patch attached conditionally pulls in nvidia-driver instead of
linux-{c6,f10}-dri through NVIDIA_GL option.

Test Plan

portlint -C ok,
poudriere bulk with OPTIONS_SET=NVIDIA_GL ok
poudriere bulk with OPTIONS_UNSET=NVIDIA_GL ok

Caveats:

  • Building emulators/linux-c6 with NVIDIA_GL enabled needs OVERRIDE_LINUX stuff, otherwise it will conflict due to nvidia-driver pulling in linux_base-f10.
  • Likewise, building emulators/linux-f10 with OVERRIDE_LINUX stuff set to c6 AND NVIDIA_GL enabled won't be possible.

[1] https://lists.freebsd.org/pipermail/freebsd-emulation/2014-September/011837.html

Diff Detail

Repository
rP FreeBSD ports repository
Lint
No Linters Available
Unit
No Unit Test Coverage

Event Timeline

xmj updated this revision to Diff 1713.Sep 22 2014, 2:40 PM
xmj retitled this revision from to Make linux metaports conditionally depend on x11/nvidia-driver.
xmj updated this object.
xmj edited the test plan for this revision. (Show Details)
xmj added reviewers: koobs, swills.
xmj edited the test plan for this revision. (Show Details)Sep 22 2014, 2:59 PM
koobs requested changes to this revision.Sep 23 2014, 10:03 AM
koobs edited edge metadata.
koobs added inline comments.
emulators/linux-c6/Makefile
94

Move options helpers above port.options include

emulators/linux-f10/Makefile
103

Move options helpers above port.options include

This revision now requires changes to proceed.Sep 23 2014, 10:03 AM

Ignore previous comment, couldn't see full file.

bsd.port.options.mk include isnt needed for options helpers, right?

Also, is DRI or GL desirable as the OPTIONS_DEFAULT (for the package?)

Consider and set accordingly.

xmj updated this revision to Diff 1726.Sep 23 2014, 10:10 AM
xmj edited edge metadata.

Remove options.mk include

xmj added a comment.Sep 23 2014, 10:12 AM

Proposed commitmessage:

Fix linux-c6/f10 metaports conflicting with nvidia-driver

linux-c6/f10 metaports pull in their respective dri implementation, which conflicts with nvidia-driver's libGL. Resolve this through adding an option for it, and conditionally pull in linux dri or nvidia-driver

Submitted by: Admir Mehic (admir@mehic.at)
PR: 193832
Approved by: koobs (mentor)

In D808#8, @koobs wrote:

Also, is DRI or GL desirable as the OPTIONS_DEFAULT (for the package?)
Consider and set accordingly.

DRI, on the assumption of internal consistency with packages, and that should you really need support for your NVIDIA GPU you would want to install from ports.

Summary of the change is 'Add NVidia GL option to fix conflicts

<detail about conflicts here>

While we're here:

Q: How are users going to know to select the option to avoid the conflict?
Q: How do package users avoid the issue since NVIDIA_GL isnt the default?

xmj added a comment.Sep 23 2014, 10:41 AM
In D808#12, @koobs wrote:

Summary of the change is 'Add NVidia GL option to fix conflicts
<detail about conflicts here>
While we're here:
Q: How are users going to know to select the option to avoid the conflict?
Q: How do package users avoid the issue since NVIDIA_GL isnt the default?

better?

Add NVIDIA_GL option to fix conflicts with Linux DRI

linux-c6/f10 metaports pull in their respective dri implementation, which
conflicts with nvidia-driver's libGL. Resolve this by adding an option for it,
and conditionally pull in either Linux DRI, or the NVIDIA driver.
Note: users of nvidia-driver will have to use ports for now.

Submitted by: Admir Mehic (admir@mehic.at)
PR: 193832
Approved by: koobs (mentor)

koobs accepted this revision.Sep 23 2014, 10:44 AM
koobs edited edge metadata.
This revision is now accepted and ready to land.Sep 23 2014, 10:44 AM
xmj closed this revision.Sep 25 2014, 6:35 AM

Landed as of 369028